$! gnm compiler build procedure
$!
$! Copyright 1976-2006 Hewlett-Packard Development Company, L.P.
$!
$! P1 is a comma-separated list of options.
$!   DEBUG (or D) generates a debugging build
$!
$!
$!
$ WRITE SYS$OUTPUT "GNM_BUILD is now running"
$
$ arch_type = f$getsyi("ARCH_TYPE")
$ If arch_type .gt 3 .or. arch_type .eq. 0
$ Then
$   write sys$output "Unrecognized OpenVMS architecture"
$   exit
$ EndIf
$
$ XTools_Flag = "FALSE"
$ CC_COMPILER = "CC"
$ if f$trnlnm("IA64_LINK") .nes. ""
$ then
$   XTools_Flag = "TRUE"
$   CC_COMPILER = "XCC"
$   arch_type = 3
$ EndIf
$
$ close/nolog foo
$ if f$search("arch_defs.tmp;") .nes. "" then delete arch_defs.tmp;*
$ open/write foo arch_defs.tmp
$ write foo "; temporary build file"
$ goto arch_type_'arch_type'
$
$
$ARCH_TYPE_1:  ! OpenVMS VAX
$ m32cmd = "macro"
$ Define/NoLog OBJ$ sys$disk:[.vax_obj]
$ if f$search("sys$disk:[]vax_obj.dir") .eqs. "" then create/directory sys$disk:[.vax_obj]
$ imgname = "GNM_VAX.EXE"
$ 
$ write foo "VAX      = 1"
$ write foo "VAXPAGE  = 1"
$
$ goto arch_type_common
$
$ARCH_TYPE_2:  ! OpenVMS Alpha
$ m32cmd = "macro/migration"
$ Define/NoLog OBJ$ sys$disk:[.alpha_obj]
$ if f$search("sys$disk:[]alpha_obj.dir") .eqs. "" then create/directory sys$disk:[.alpha_obj]
$ imgname = "GNM_Alpha.EXE"
$
$ write foo "EVAX     = 1"
$ write foo "ALPHA    = 1"
$ write foo "BIGPAGE  = 1"
$
$ goto arch_type_common
$
$ARCH_TYPE_3:  ! OpenVMS I64
$ m32cmd = "macro/migration"
$ Define/NoLog OBJ$ sys$disk:[.ia64_obj]
$ if f$search("sys$disk:[]ia64_obj.dir") .eqs. "" then create/directory sys$disk:[.ia64_obj]
$ imgname = "GNM_I64.EXE"
$
$ write foo "IA64     = 1"
$ write foo "BIGPAGE  = 1"
$
$ goto arch_type_common
$
$
$arch_type_common:  ! Common set-up
$
$ write foo "AXTOOLS  = 0"
$ write foo "IXTOOLS  = 0"
$ write foo "IXVMS    = 0"
$ write foo "AXVMS    = 0"
$ write foo "ADDRESSBITS = 32"
$ close foo
$
$ WRITE SYS$OUTPUT "Preparing to build the GNM image ''imgname'"
$
$ ccflags = "/nodebug/opt"
$ linkflags = "/nodebug"
$ P1LEN = F$LENGTH(",''P1',")
$ debug_build_flag = "FALSE"
$ IF F$LOCATE(",D,",",''P1',") .NE. P1LEN .OR. F$LOCATE(",DEBUG,",",''P1',") .NE. P1LEN
$ THEN
$    write sys$output "Debugging requested"
$    ccflags = "/debug/noopt/define=debug"
$    linkflags = "/debug"
$    debug_build_flag = "TRUE"
$ ENDIF
$
$ WRITE SYS$OUTPUT "Seeking the SDL tool"
$ sdlcom :== "?"
$ if f$search("srh:[sdl]sdl.com")   .nes. "" then   sdlcom :== srh:[sdl]sdl.com
$ if f$search("sys$login:sdl.com") .nes. "" then   sdlcom :== sys$login:sdl.com
$ if f$search("sdl_path:sdl.com")   .nes. "" then   sdlcom :== sdl_path:sdl.com
$ if f$search("sys$system:sdl.com") .nes. "" then   sdlcom :== sys$system:sdl.com
$ if f$search("sys$system:sdl$main.exe") .nes. "" then   sdlcom :== "NLA0:"
$ if ( sdlcom .eqs. "?" )
$ then
$   write sys$output "%GNM-E-NOSDL, the SDL compiler is not available on this system"
$   write sys$output "-GNM-E-LOOKED, the SDL search checked   sys$system:sdl.com"
$   write sys$output "-GNM-E-LOOKED, the search also checked  sys$login:sdl.com"
$   write sys$output "-GNM-E-LOOKED, the search also checked  sdl_path:sdl.com"
$   write sys$output "-GNM-E-LOOKED, the search also checked  srh:[sdl]sdl.com"
$   exit
$ endif
$ WRITE SYS$OUTPUT "Loading the SDL tool"
$ @'sdlcom' /OUTPUT=NLA0:
$
$
$ WRITE SYS$OUTPUT "Recreating GNM libraries"
$
$ if f$search("OBJ$:GNM.OLB") .nes. "" then delete OBJ$:GNM.OLB;*
$ Librar/Create/Object OBJ$:GNM.OLB
$ if f$search("OBJ$:GNM.MLB") .nes. "" then delete OBJ$:GNM.MLB;*
$ Librar/Create/Macro OBJ$:GNM.MLB
$
$ if f$search("OBJ$:GNM.EXE") .nes. "" then delete OBJ$:GNM.EXE;*
$
$
$ WRITE SYS$OUTPUT "Commencing compilations"
$
$!  Now to actually build some stuff...
$!
$ if f$search("OBJ$:tsearch.obj") .nes. "" then delete OBJ$:tsearch.obj;*
$ CC_COMPILER 'ccflags' /include=sys$disk:[]/object=OBJ$: TSEARCH
$ Librar/Create/Object/Insert OBJ$:GNM.OLB OBJ$:tsearch
$
$ if f$search("GNMDEF.H") .nes. "" then delete GNMDEF.H;*
$ if f$search("GNMDEF.MAR") .nes. "" then delete GNMDEF.MAR;*
$ SDL/ALPHA/LANG=C/COPYRIGHT GNMDEF
$ SDL/ALPHA/LANG=MACRO/COPYRIGHT GNMDEF
$ Librar/Insert OBJ$:GNM.MLB GNMDEF.MAR
$
$ if f$search("OBJ$:gnmparsetable.obj") .nes. "" then delete OBJ$:gnmparsetable.obj;*
$ 'm32cmd'/object=OBJ$:gnmparsetable.obj arch_defs.tmp+gnmparsetable.mar+OBJ$:GNM.MLB/Library
$ Librar/Insert OBJ$:GNM.OLB OBJ$:gnmparsetable
$
$ if f$search("arch_defs.tmp;") .nes. "" then delete arch_defs.tmp;*
$
$ if f$search("OBJ$:GNM.OBJ") .nes. "" then delete OBJ$:GNM.OBJ;*
$ CC_COMPILER 'ccflags' /include=sys$disk:[]/object=OBJ$:  GNM
$ Librar/Insert OBJ$:GNM.OLB OBJ$:GNM
$
$ link/executable=OBJ$:GNM.EXE 'linkflags' GNMVERSION.OPT/OPTION,OBJ$:GNM.OLB/LIB/INCL=GNM,OBJ$:GNM.OLB/LIB/SELECTIVE
$
$ if .not. debug_build_flag
$ then
$   if f$search(imgname) .nes. "" then DELETE 'imgname';*
$   if f$search("GNMDEF.H") .nes. "" then DELETE GNMDEF.H;*
$   if f$search("GNMDEF.MAR") .nes. "" then DELETE GNMDEF.MAR;*
$ endif
$
$ copy OBJ$:GNM.EXE 'imgname'/LOG
$
$
$ WRITE SYS$OUTPUT "Building of the GNM image ''imgname' has completed"
$
$ Exit
